% This function generates two overlapping rectangles comparing the
% characteristics of two different things such as tasks or recipes.

% The names cell array contains the names of two things to be compared.
% These labels go on the side of each rectangle.
names = {'Task 1', 'Task 2'};

% The ingredients cell arrays contain the constituents of each rectangle.
% The name of each constituent goes in the first element of each internal
% cell array and the size of each circle goes in the second element of each
% internal cell array.
ingredients1 = {{'Electrode 1', 5}, {'Electrode 2', 2}, {'Electrode 3', 6}};

ingredients2 = {{'Electrode 1', 5}, {'Electrode 4', 3}, {'Electrode 5', 4}};

% The compounds cell array contains the list of constituents that will be
% presented in a column next to the two overlapping rectangles. These need
% not match the constituents present in the ingredients cell arrays.
compounds = {'Electrode 1', 'Electrode 2', 'Electrode 3', 'Electrode 4', 'Electrode 5'};

% The connections cell array contains the list of connections between the
% constituents placed in the rectangles and the constituents placed in the
% adjacent column. The first element of each internal cell array contains
% a constituent from the rectangles and the second element contains a
% constituent from the column. A line is drawn between all connected
% constituents.
connections = {{'Electrode 1', 'Electrode 2'}, {'Electrode 1', 'Electrode 4'}, {'Electrode 2', 'Electrode 4'}, {'Electrode 2', 'Electrode 5'}, {'Electrode 3', 'Electrode 1'}, {'Electrode 3', 'Electrode 2'}, {'Electrode 3', 'Electrode 4'}, {'Electrode 4', 'Electrode 1'}, {'Electrode 5', 'Electrode 2'}, {'Electrode 5', 'Electrode 4'}};

% The first element of this cell array contains text to be written over the
% top of the rectangles. The second element of this cell array contains
% text to be written over the top of the column.
labels = {'Cause', 'Effect'};

% The parameter 'output' dictates how the figure will be presented ('openhtml' opens the html
% file automatically, 'pdf' automatically generates a pdf of the pyramid,
% and 'openpdf' automatically opens the generated pdf).
drawrectangle(names, ingredients1, ingredients2, compounds, connections, labels, 'openhtml');