% Use this function to generate node-link diagrams in an html file.
% Set the 'output' parameter to 'openhtml' to have the html file open
% automatically, or to 'pdf' to have a pdf of the diagram be generated
% automatically, or to 'openpdf' to have the pdf open automatically.
% See examplebubble.m and examplebubble2.m for detailed usage instructions.

function [] = drawbubbles(nodes, links, config, output)

    jsonfileID = fopen('bubbleredux.json', 'w');

    fprintf(jsonfileID, '{"nodes":[');

    for i = 1:length(nodes)

        if i ~= length(nodes); 

            fprintf(jsonfileID, ['{']);
% should probably remove
%             if config.x + config.y + config.name + config.size + config.group == 0
%                 fprintf(jsonfileID, ['}, ']);
%             end
            
            if config.x ~= 0, fprintf(jsonfileID, ['"x": ' num2str(nodes{i}{config.x}) ]); 
                if config.y + config.name + config.size + config.group == 0, fprintf(jsonfileID, ['}, ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.y ~= 0, fprintf(jsonfileID, ['"y": ' num2str(nodes{i}{config.y}) ]); 
                if config.name + config.size + config.group == 0, fprintf(jsonfileID, ['}, ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.name ~= 0, fprintf(jsonfileID, ['"name": "' nodes{i}{config.name} '"']); 
                if config.size + config.group == 0, fprintf(jsonfileID, ['}, ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.size ~= 0, fprintf(jsonfileID, ['"size": ' num2str(nodes{i}{config.size}) ]); 
                if config.group == 0, fprintf(jsonfileID, ['}, ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.group ~= 0, fprintf(jsonfileID, ['"group": ' num2str(nodes{i}{config.group}) '}, ']); end
            
        else

            fprintf(jsonfileID, ['{']);
            if config.x ~= 0, fprintf(jsonfileID, ['"x": ' num2str(nodes{i}{config.x}) ]); 
                if config.y + config.name + config.size + config.group == 0, fprintf(jsonfileID, ['}], ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.y ~= 0, fprintf(jsonfileID, ['"y": ' num2str(nodes{i}{config.y}) ]); 
                if config.name + config.size + config.group == 0, fprintf(jsonfileID, ['}], ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.name ~= 0, fprintf(jsonfileID, ['"name": "' nodes{i}{config.name} '"']); 
                if config.size + config.group == 0, fprintf(jsonfileID, ['}], ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.size ~= 0, fprintf(jsonfileID, ['"size": ' num2str(nodes{i}{config.size}) ]); 
                if config.group == 0, fprintf(jsonfileID, ['}], ']); else fprintf(jsonfileID, ', '); end 
            end
            if config.group ~= 0, fprintf(jsonfileID, ['"group": ' num2str(nodes{i}{config.group}) '}], ']); end

        end

    end

    linkslength = length(links);

    if isempty(links) == 0
    
        fprintf(jsonfileID, '\n"links": [');

        for i = 1:length(links)

            if i ~= linkslength;

                if (config.linkstrength)

                    fprintf(jsonfileID, ['{"source": ' num2str(links{i}{1}) ', "target": ' num2str(links{i}{2}) ', "linkwidth": ' num2str(links{i}{3}) '}, ']);

                else

                    fprintf(jsonfileID, ['{"source": ' num2str(links{i}{1}) ', "target": ' num2str(links{i}{2}) '}, ']);

                end

            else

                if (config.linkstrength)

                    fprintf(jsonfileID, ['{"source": ' num2str(links{i}{1}) ', "target": ' num2str(links{i}{2}) ', "linkwidth": ' num2str(links{i}{3}) '}], ']);

                else

                    fprintf(jsonfileID, ['{"source": ' num2str(links{i}{1}) ', "target": ' num2str(links{i}{2}) '}], ']);

                end

            end

        end

    end
    
    if isempty(links)
        fprintf(jsonfileID, '\n"links": {"source": 0, "target": 0, "linkwidth": 0}, ');
    end
    
    fprintf(jsonfileID, ['\n"config": {"legend1": "' config.legendtext1 '", "legend2": "' config.legendtext2 '", "forcedirected": ' num2str(config.forcedirected) ', "image": ' num2str(config.image) ', "imagewidth": ' num2str(config.imagewidth) ', "imagepath": "' config.imagepath '", "imageheight": ' num2str(config.imageheight) ', "xMin": ' num2str(config.xMin) ', "xMax": ' num2str(config.xMax) ', "yMin": ' num2str(config.yMin) ', "yMax": ' num2str(config.yMax) ', "linkwidth": ' num2str(config.linkwidth) ', "x": ' num2str(config.x) ', "y": ' num2str(config.y) ', "name": ' num2str(config.name) ', "size": ' num2str(config.size) ', "group": ' num2str(config.group) ', "linkstrength": ' num2str(config.linkstrength) ', "drawnodes": ' num2str(config.drawnodes) ', "nodetext": ' num2str(config.nodetext) ', "textcolor": "' config.textcolor '", "nodesize": ' num2str(config.nodesize) ', "nodesizemin": ' num2str(config.nodesizemin) ', "nodesizemax": ' num2str(config.nodesizemax) ', "nodecolor": "' config.nodecolor '", "drawlinks": ' num2str(config.drawlinks) ', "linkscolor": "' config.linkscolor '", "edgebundling": ' num2str(config.edgebundling) ', "cycles": ' num2str(config.cycles) ', "iterations": ' num2str(config.iterations) ', "stepsize": ' num2str(config.stepsize) ', "drawarrows": ' num2str(config.drawarrows) ', "arrowsize": ' num2str(config.arrowsize) ', "arrowcolor": "' config.arrowcolor '", "legend": ' num2str(config.legend) ', "fixed": ' num2str(config.fixed) '}}']);
    
    html = fileread('bubbleredux.html');
    %html = fileread('Data Visualization Package/HTML/bubbleredux.html');

    htmlfileID = fopen('newbubbles.html', 'w');
    
    fprintf(htmlfileID, html);
    
    if strcmp(output, 'openhtml');
        
        system('open -a Safari newbubbles.html');
    
    end
    
    if strcmp(output, 'pdf');
        
        system('/System/Library/Printers/Libraries/convert -f newbubbles.html -o newbubbles.pdf');
        
    end
        
    if strcmp(output, 'openpdf');
        
        system('/System/Library/Printers/Libraries/convert -f newbubbles.html -o newbubbles.pdf');
        system('open -a Preview newbubbles.pdf');
        
    end

end

