% This function generates a pyramid containing the six Brodmann areas with
% the highest average outgoing strength of causality, and pairs and
% triplets thereof. For detailed usage instructions see examplepyramid.m.

function [] = drawpyramid(data, color, output)

    json = mat2json(data);
    
    jsonfileID = fopen('newpyramid.json', 'w');
    fprintf(jsonfileID, ['{"array": ' num2str(json) ' }']);
    
    jsonfileID = fopen('newpyramidcolor.json', 'w');
    fprintf(jsonfileID, ['{"color": "' color '" }']);
    
    html = fileread('Data Visualization Package/HTML/pyramid.html');
    
    htmlfileID = fopen('newpyramid.html', 'w');

    fclose(jsonfileID);

    fprintf(htmlfileID,html);

    fclose(htmlfileID);
    
    if strcmp(output, 'openhtml');
        
        system('open -a Safari newpyramid.html');
    
    end
    
    if strcmp(output, 'pdf');
        
        system('/System/Library/Printers/Libraries/convert -f newpyramid.html -o newpyramid.pdf');
        
    end
        
    if strcmp(output, 'openpdf');
        
        system('/System/Library/Printers/Libraries/convert -f newpyramid.html -o newpyramid.pdf');
        system('open -a Preview newpyramid.pdf');
        
    end
    
end