% This function generates two overlapping rectangles comparing the
% characteristics of two different things such as tasks or recipes. For
% detailed usage instructions, see examplerectangle.m.

function [] = drawrectangle(names, ingredients1, ingredients2, compounds, connections, labels, output)

    names = mat2json(names);
    ingredients1 = mat2json(ingredients1);
    ingredients2 = mat2json(ingredients2);
    compounds = mat2json(compounds);
    connections = mat2json(connections);
    labels = mat2json(labels);
    
    namesfileID = fopen('newrectanglenames.json', 'w');
    ingredients1fileID = fopen('newrectangleingredients1.json', 'w');
    ingredients2fileID = fopen('newrectangleingredients2.json', 'w');
    compoundsfileID = fopen('newrectanglecompounds.json', 'w');
    connectionsfileID = fopen('newrectangleconnections.json', 'w');
    labelsfileID = fopen('newrectanglelabels.json', 'w');
    
    fprintf(namesfileID, names);
    fprintf(ingredients1fileID, ingredients1);
    fprintf(ingredients2fileID, ingredients2);
    fprintf(compoundsfileID, compounds);
    fprintf(connectionsfileID, connections);
    fprintf(labelsfileID, labels);
    
    html = fileread('Data Visualization Package/HTML/rectangle.html');
    htmlfileID = fopen('newrectangle.html', 'w');
    
    fprintf(htmlfileID, html);
    
    fclose(namesfileID);
    fclose(ingredients1fileID);
    fclose(ingredients2fileID);
    fclose(compoundsfileID);
    fclose(connectionsfileID);
    fclose(labelsfileID);
    fclose(htmlfileID);
    
    if strcmp(output, 'openhtml');
        
        system('open -a Safari newrectangle.html');
    
    end
    
    if strcmp(output, 'pdf');
        
        system('/System/Library/Printers/Libraries/convert -f newrectangle.html -o newrectangle.pdf');
        
    end
        
    if strcmp(output, 'openpdf');
        
        system('/System/Library/Printers/Libraries/convert -f newrectangle.html -o newrectangle.pdf');
        system('open -a Preview newrectangle.pdf');
        
    end
    
end

    