d3.json("bubbleredux.json", function(json) {
	if (json.config.image) {	
		if (json.config.image) {
			var imageW = json.config.imagewidth,
				imageH = json.config.imageheight;
			
			if (imageW > imageH) {
				var divW = 300,
					divH = imageH * 300 / imageW,
					top = 150 - divH / 2 + 8;
					left = 8;
			}
			
			if (imageH > imageW) {
				var divH = 300,
					divW = imageW * 300 / imageW,
					top = 8,
					left = 150 - divW / 2 + 8;
			}
			
			document.write("<style type='text/css'> #brainimage { position: absolute; left:" + left + "px; top:" + top + "px; z-index: -1; }</style>");
			document.write('<div id="brainimage"><img src=' + json.config.imagepath + ' height=' + divH + ' width=' + divW + '></div>');
		}
	
		var width = 320,
			height = 300;
		
	
		
		if (json.config.image) {
			var svg = d3.select("body").append("svg")
					.attr("width", width)
					.attr("height", height);
		}

		var arrowSize = json.config.arrowsize,
			arrowColor = json.config.arrowcolor;
            
        svg.append("svg:defs").selectAll("marker")
            .data(["arbitraryString"])
          .enter().append("svg:marker")
            .attr("id", "arrowhead")
            //.attr("viewBox", "0 -5 20 20")
			.attr("viewBox", "0 -5 " + arrowSize + " " + arrowSize)
            .attr("refX", 5)
            .attr("refY", 0)
            .attr("markerWidth", 6)
            .attr("markerHeight", 6)
            .attr("orient", "auto")
			.attr("fill", arrowColor)
          .append("svg:path")
            .attr("d", "M0,-5L10,0L0,5");
	
        var radiusMax = width / 11,
            radiusMin = width / 50;

		if (json.config.nodesizemin) radiusMin = json.config.nodesizemin;
        if (json.config.nodesizemax) radiusMax = json.config.nodesizemax;
		
		var linkWidthMax = width / 18,
			linkWidthMin = width / 300;
		
		var force = d3.layout.force()
			.gravity(0.125)
			.charge(-200)
			.linkDistance(175)
			.linkStrength(0.025)
			.size([width, height]);
		
		var legend = d3.select("body")
				.append("svg")
				.attr("width", 250)
				.attr("height", height);
	
		//json.nodes.push({"x": -24, "y": 75}, {"x": -24, "y": -42}, {"x": 67, "y": 8}, {"x": -101, "y": 8});
		
		if (json.config.image) {
			var dataMinXValue = json.config.xMax, 
				dataMaxXValue = json.config.xMin, 																				
				dataMinYValue = json.config.yMin,
				dataMaxYValue = json.config.yMax;
		
			/*json.nodes.forEach(function(d) {
				d.x = Math.random() * dataMaxXValue;
				d.y = Math.random() * dataMaxYValue;
			});*/
	
			var xScale = d3.scale.linear()
				.domain([dataMinXValue, dataMaxXValue])
				.range([left - 8, left + divW - 8]);
	
			var yScale = d3.scale.linear()
				.domain([dataMinYValue, dataMaxYValue])
				.range([top + divH - 8, top - 8]);
			 
			json.nodes.forEach(function(d) {
				d.x = xScale(d.x);
				d.y = yScale(d.y);
				if (json.config.fixed) d.fixed = true;
			});
		}
	
		var node = svg.selectAll(".node") // This is necessary for the tick function
			.data(json.nodes)
			.enter().append("g")
			.attr("class", "node");
	
		if (json.config.size !== 0) {
			var radius = d3.scale.sqrt()
				.domain(d3.extent(json.nodes, function(d) { return d.size; }))
				.range([radiusMin, radiusMax]);
		} else {
			json.nodes.forEach(function(d) {
				d.size = json.config.nodesize;
			});
				
			radiusMin = json.config.nodesize;
			radiusMax = json.config.nodesize;
			
			var radius = d3.scale.sqrt()
				.domain(d3.extent(json.nodes, function(d) { return d.size; }))
				.range([radiusMin, radiusMax]);
		}
	
		force.nodes(json.nodes)
			.links(json.links)
	
		if (json.config.forcedirected == 1) {
			force.start();
			for (var i = 0; i < 1000; i++) force.tick(); // Necessary for the edge bundling to work		
			force.stop();
		}
		
		if (json.config.x && json.config.y) {
		
			force.on("tick", function() {
				//if (json.config.drawnodesnodes == 1) {
					node.attr("x", function(d) { return d.x = Math.max(radius(d.size), Math.min(width - radius(d.size), d.x)); })
						.attr("y", function(d) { return d.y = Math.max(radius(d.size), Math.min(height - radius(d.size), d.y)); });
				//}
				
				//if (json.config.drawlinks == 1) {
					link.attr("x1", function(d) { return d.source.x; })
						.attr("y1", function(d) { return d.source.y; })
						.attr("x2", function(d) { return d.target.x; })
						.attr("y2", function(d) { return d.target.y; });
				//}
			
				/*if (json.config.drawnodes == 1)*/ node.attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; });
			});
	
		}
	
	
		if (json.config.x == 0 && json.config.y == 0) {
	
			force.on("tick", function() {
				//if (json.config.drawnodesnodes == 1) {
					node.attr("x", function(d) { return d.x = Math.max(radius(d.size), Math.min(width - radius(d.size), d.x)); })
						.attr("y", function(d) { return d.y = Math.max(radius(d.size), Math.min(height - radius(d.size), d.y)); });
				//}
				
				//if (json.config.drawlinks == 1) {
					link.attr("x1", function(d) { return d.source.x; })
						.attr("y1", function(d) { return d.source.y; })
						.attr("x2", function(d) { return d.target.x; })
						.attr("y2", function(d) { return d.target.y; });
				//}
			
				/*if (json.config.drawnodes == 1)*/ node.attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; });
			});
	
		}
	
		force.start();
	
		if (json.config.drawlinks == 1) {
			var link = svg.selectAll(".link")
				.data(json.links);
	
			if (json.config.linkstrength) {
				var linkWidth = d3.scale.linear()
					.domain(d3.extent(json.links, function(d) { return d.linkwidth; }))
					.range([linkWidthMin, linkWidthMax]);
			} else {
				var linkWidth = json.config.linkwidth; 
			}
			
			if (json.config.edgebundling == 0) {
				if (1) {
                    
                    link.enter().append("line")
                        .attr("class", "link")
                        .attr("stroke-width", function(d) { if (json.config.linkstrength) { return linkWidth(d.linkwidth); } else { return linkWidth; }})
                        .attr("stroke", json.config.linkscolor)
                        .attr("marker-end", "url(#arrowhead)");
                
                } else {
                
                    link.enter().append("line")
                        .attr("class", "link")
                        .attr("stroke-width", function(d) { if (json.config.linkstrength) { return linkWidth(d.linkwidth); } else { return linkWidth; }})
                        .attr("stroke", json.config.linkscolor);
                }
			}
	
		}
        
        
		
		if (json.config.forcedirected == 0) {
			for (var i = 0; i < json.nodes.length; i++) {
				if (typeof json.nodes[i].x !== 'undefined' && typeof json.nodes[i].y !== 'undefined') json.nodes[i].fixed = true;
			}
		}
		
		/*var node = svg.selectAll(".node") // This is necessary for the tick function
			.data(json.nodes)
			.enter().append("g")
			.attr("class", "node");*/
		
		/*if (json.config.forcedirected == 1) {
			force.start();
			for (var i = 0; i < 1000; i++) force.tick(); // Necessary for the edge bundling to work		
			force.stop();
		}*/
	
		if (json.config.edgebundling && json.config.drawlinks) { // make sure xs and ys exist
			var edgeList = [];
			
			for (var i = 0; i < json.links.length; i++) {
				edgeList.push([{x: json.links[i].source.x, y: json.links[i].source.y}, {x: json.links[i].target.x, y: json.links[i].target.y}]); 
			}
	
			edgebundle(edgeList, json.config.cycles, json.config.iterations, json.config.stepsize, json.config.linkscolor); // This draws the bundled links, has to go after tick function in case xs and ys aren't supplied.
			//alert([edgeList, json.config.cycles, json.config.iterations, json.config.stepsize, json.config.linkscolor]);
		}
	
		if (json.config.edgebundling == 0) node.call(force.drag);
		
		if (json.config.colordependency == 'size' || json.config.colordependency == 'group' || json.config.colordependency == 'x' || json.config.colordependency == 'y') {
			var colorDependency = json.config.colordependency;
		} else {
			var colorDependency = "index";
		}
	
		var color = d3.scale.linear()
			.domain([d3.extent(json.nodes, function (d) { if (colorDependency == "index") { return d.index; } else { return eval("d" + "." + colorDependency); }})])
			.range(json.config.nodecolor);
	
		/*if (json.config.size) {
			var circleRadius = radius(eval("d" + "." + "size"));
		} else {
			var circleRadius = json.config.nodesize;
		}*/
		
		if (json.config.drawnodes) {
		
			/*node.append("circle") // This draws the circles onto the g elements
				.attr("r", function(d) { return radius(d.size); }) // radius(d.size) or nodesize
				.attr("fill", json.config.nodecolor)//function(d) { return color(eval("d" + "." + colorDependency)); }) // color(d.group) (offer color options? in config) or node color
				.attr("stroke", "rgba(0, 0, 0, 0.6)")
				.attr("stroke-width", 1);*/
			
			if (json.config.nodetext) {
				node.append("text")
					.attr("text-anchor", "middle")
					.attr("dy", ".35em")
					.attr("font-size", function(d) { if (json.config.size) { return Math.min(15, Math.max(10, Math.sqrt(100 * d.size / Math.PI))); } else { return Math.min(15, Math.max(10, Math.sqrt(100 * json.config.nodesize / Math.PI))); }})
					.attr("font-family", "arial")
					.attr("fill", json.config.textcolor)
					.text(function(d) { return d.name });
			}
		
		}
		if (json.config.fixed || json.config.edgebundling) json.nodes.forEach(function(d) { d.fixed = true; });
		
		json.nodes.forEach(function(d) { d.fixed = true; });

        
        
        var fillScale = d3.scale.linear()
                            .domain([0, 1])
                            .range(["black", "red"]);
        
		//if (json.config.edgebundling && json.config.drawnodes) {
			if (json.config.drawnodes) {	
                json.nodes.forEach(function(d) {
					svg.append("circle")
						.attr("r", function() { return radius(d.size); })
						.attr("cx", d.x)
						.attr("cy", d.y)
                        .attr("fill", fillScale(d.size))
						//.attr("fill", json.config.nodecolor)//function() { return color(eval("d" + "." + colorDependency)); })
						.attr("stroke", fillScale(d.size))
						.attr("stroke-width", 1);
            
				
					if (json.config.nodetext) {
						svg.append("text")
							.attr("text-anchor", "middle")
							.attr("dy", ".35em")
							.attr("font-size", function() { if (json.config.size) { return Math.min(15, Math.max(10, Math.sqrt(100 * d.size / Math.PI))); } else { return Math.min(15, Math.max(10, Math.sqrt(100 * json.config.nodesize / Math.PI))); }})
							.attr("font-family", "arial")
							.attr("x", d.x)
							.attr("y", d.y)
							.attr("fill", json.config.textcolor)
							.text(d.name);
					}
				});
            }
		//}
		
		/*var xScale = d3.scale.linear()
			.domain([dataMinXValue, dataMaxXValue])
			.range([left - 8, left + divW - 8]);
	
		var yScale = d3.scale.linear()
			.domain([dataMinYValue, dataMaxYValue])
			.range([top + divH - 8 + 12, top - 8 + 12]);*/
	
		//if (json.config.fixed || json.config.edgebundling) json.nodes.forEach(function(d) { d.fixed = true; });
		/*json.nodes.forEach(function(d) {
				d.x = xScale(d.x);
				d.y = yScale(d.y);
				if (json.config.fixed) d.fixed = true;
		});*/
		
		if (json.config.legend) { // check for elements of legend
			var nodeLegend = {x: 50, y: 20};
			
			legend.append("text")
				.attr("x", nodeLegend.x)
				.attr("y", nodeLegend.y)
				.attr("font-size", 15)
				.attr("font-family", "arial")
				.text(json.config.legend1);
			
			legend.append("circle")
				.attr("r", radiusMax)
				.attr("cx", nodeLegend.x + radiusMax)
				.attr("cy", nodeLegend.y + radiusMax + 20)
				.attr("fill", "rgb(179, 195, 194)")
				.attr("stroke", "rgba(0, 0, 0, 0.45)")
				.attr("stroke-width", 1.75);
			
			legend.append("circle")
				.attr("r", d3.round((radiusMax + radiusMin) / 2))
				.attr("cx", nodeLegend.x + radiusMax)
				.attr("cy", nodeLegend.y + 2 * radiusMax + d3.round((radiusMax + radiusMin) / 2) + 30)
				.attr("fill", "rgb(179, 195, 194)")
				.attr("stroke", "rgba(0, 0, 0, 0.45)")
				.attr("stroke-width", 1.75);
		
			legend.append("circle")
				.attr("r", radiusMin)
				.attr("cx", nodeLegend.x + radiusMax)
				.attr("cy", nodeLegend.y + 2 * radiusMax + 2 * d3.round((radiusMax + radiusMin) / 2) + radiusMin + 40)
				.attr("fill", "rgb(179, 195, 194)")
				.attr("stroke", "rgba(0, 0, 0, 0.45)")
				.attr("stroke-width", 1.75);
		
			legend.append("text")
				.attr("x", nodeLegend.x + radiusMax + 70)
				.attr("y", nodeLegend.y + radiusMax + 20)
				.attr("font-size", 11)
				.attr("font-family", "arial")
				.attr("dy", "0.35em")
				.text(d3.max(json.nodes, function(d) { return d.size; }));
		
			legend.append("text")
				.attr("x", nodeLegend.x + radiusMax + 70)
				.attr("y", nodeLegend.y + 2 * radiusMax + d3.round((radiusMax + radiusMin) / 2) + 30)
				.attr("font-size", 11)
				.attr("font-family", "arial")
				.attr("dy", "0.35em")
				.text(d3.round((d3.max(json.nodes, function(d) { return d.size; }) + d3.min(json.nodes, function(d) { return d.size; })) / 2));
		
			legend.append("text")
				.attr("x", nodeLegend.x + radiusMax + 70)
				.attr("y", nodeLegend.y + 2 * radiusMax + 2 * d3.round((radiusMax + radiusMin) / 2) + radiusMin + 40)
				.attr("font-size", 11)
				.attr("font-family", "arial")
				.attr("dy", "0.35em")
				.text(d3.min(json.nodes, function(d) { return d.size; }));
		
			var linkLegend = {x: nodeLegend.x, y: nodeLegend.y + 2 * radiusMax + 2 * d3.round((radiusMax + radiusMin) / 2) + 2 * radiusMin + 80};
		
			legend.append("text")
				.attr("x", linkLegend.x)
				.attr("y", linkLegend.y)
				.attr("font-size", 15)
				.attr("font-family", "arial")
				.text(json.config.legend2);
		
			legend.append("rect")
				.attr("x", linkLegend.x)
				.attr("y", linkLegend.y + 20)
				.attr("height", linkWidthMax)
				.attr("width", 50)
				.attr("fill", "rgb(109, 124, 124)");
		
			legend.append("rect")
				.attr("x", linkLegend.x)
				.attr("y", linkLegend.y + linkWidthMax + 38)
				.attr("height", d3.round((linkWidthMax + linkWidthMin) / 2))
				.attr("width", 50)
				.attr("fill", "rgb(109, 124, 124)");
		
			legend.append("rect")
				.attr("x", linkLegend.x)
				.attr("y", linkLegend.y + 2 * linkWidthMax + 50)
				.attr("height", linkWidthMin)
				.attr("width", 50)
				.attr("fill", "rgb(109, 124, 124)");
		
			legend.append("text")
				.attr("x", linkLegend.x + 100)
				.attr("y", linkLegend.y + 20)
				.attr("dy", linkWidthMax / 2 + 5)
				.attr("font-family", "arial")
				.attr("font-size", 11)
				.text(d3.max(json.links, function(d) { return d.linkwidth; }));
		
			legend.append("text")
				.attr("x", linkLegend.x + 100)
				.attr("y", linkLegend.y + linkWidthMax + 38)
				.attr("dy", 9)
				.attr("font-family", "arial")
				.attr("font-size", 11)
				.text(d3.round((d3.max(json.links, function(d) { return d.linkwidth; }) + d3.min(json.links, function(d) { return d.linkwidth; })) / 2));
		
			legend.append("text")
				.attr("x", linkLegend.x + 100)
				.attr("dx", "0.35em")
				.attr("y", linkLegend.y + 2 * linkWidthMax + 52)
				.attr("dy", 5)
				.attr("font-family", "arial")
				.attr("font-size", 11)
				.text(d3.min(json.links, function(d) { return d.linkwidth; }));
		}
	}
});
