function edgebundle(edges, cycles, initialIterations, initialStepSize, color) {
	var pathPoints = [];

	//var color = "rgb(100, 123, 165)";
	//var cycles = 8; // Set number of cycles to perform
	//var initialIterations = 50; // Set number of iterations to perform on the first cycle
	var decrementFactor = 2 / 3; // The factor by which the number of iterations decreases after each cycle
	//var initialStepSize = 2; // Set size of steps in first cycle
	var initialControlPoints = 1; // Set number of control points on each line for the first cycle
	var tension = 0.9; // Between 0 and 1, set the paths' adherence to the control points
	var compatibilityThreshold = 0.1 // Between 0 and 1, set threshold for evaluation
	var K = 100 // Spring constant
	
	
	for (var i = 0; i < cycles; i++) {
	
		iterations = Math.round(initialIterations * Math.pow(decrementFactor, i));
		stepSize = initialStepSize / Math.pow(2, i);
		controlPoints = initialControlPoints + i;
		
		if (i == 0) {
		
			for (var j = 0; j < edges.length; j++) {
				
				var start = {x: edges[j][0].x, y: edges[j][0].y};
				var end = {x: edges[j][1].x, y: edges[j][1].y};
				var tempEdge = [];
				
				for (var k = 0; k < 1; k++) {
					
					if (start.x - end.x != 0) {
						
						xMin = Math.min(start.x, end.x);
						xMax = Math.max(start.x, end.x);
						xValue = xMin + (xMax - xMin) / 2;
						yMin = Math.min(start.y, end.y);
						yMax = Math.max(start.y, end.y);
						yValue = yMin + (yMax - yMin) / 2;
						tempEdge[k + 1] = {x: xValue, y: yValue};
					
					}
					
					else {
					
						yMin = Math.min(start.y, end.y);
						yMax = Math.max(start.y, end.y);
						yValue = yMin + (yMax - yMin) / 2;
						tempEdge[k + 1] = {x: start.x, y: yValue};
						
					}
					
				}
				
				tempEdge[0] = {x: start.x, y: start.y};
				tempEdge[controlPoints + 1] = {x: end.x, y: end.y};
				pathPoints[j] = tempEdge.slice(0);
				
			}
			
		}
		
		else {
		
			for (var j = 0; j < edges.length; j++) {
				
				var start = {x: edges[j][0].x, y: edges[j][0].y};
				var end = {x: edges[j][1].x, y: edges[j][1].y};				
				tempEdge = [];
				
				for (var k = 0; k < controlPoints; k++) {
							
						xMin = Math.min(newPositions[j][k].x, newPositions[j][k + 1].x);
						xMax = Math.max(newPositions[j][k].x, newPositions[j][k + 1].x);
						xValue = xMin + (xMax - xMin) / 2;
						yMin = Math.min(newPositions[j][k].y, newPositions[j][k + 1].y);
						yMax = Math.max(newPositions[j][k].y, newPositions[j][k + 1].y);
						yValue = yMin + (yMax - yMin) / 2;
						tempEdge[k + 1] = {x: xValue, y: yValue};
					
				}
				
				tempEdge[0] = {x: start.x, y: start.y};
				tempEdge[controlPoints + 1] = {x: end.x, y: end.y};
				pathPoints[j] = tempEdge.slice();
				
			}
			
		}
		
		newPositions = $.extend(true, [], pathPoints);
			
		for (var j = 0; j < iterations; j++) {
			
			for (var k = 0; k < pathPoints.length; k++) { // Selects path to modify
			
				edgeKComponents = {x: Math.abs(pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x), y: Math.abs(pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y)};
				edgeKLength = Math.sqrt(edgeKComponents.x * edgeKComponents.x + edgeKComponents.y * edgeKComponents.y);
				xKMin = Math.min(pathPoints[k][0].x, pathPoints[k][pathPoints[k].length - 1].x);
				xKMax = Math.max(pathPoints[k][0].x, pathPoints[k][pathPoints[k].length - 1].x);
				yKMin = Math.min(pathPoints[k][0].y, pathPoints[k][pathPoints[k].length - 1].y);
				yKMax = Math.max(pathPoints[k][0].y, pathPoints[k][pathPoints[k].length - 1].y);
				kSightLine0 = [{x: 100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][0].x, y: 100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][0].y}, {x: -100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][0].x, y: -100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][0].y}];
				kSightLine1 = [{x: 100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][pathPoints[k].length - 1].x, y: 100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][pathPoints[k].length - 1].y}, {x: -100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][pathPoints[k].length - 1].x, y: -100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][pathPoints[k].length - 1].y}];
				
				for (var l = 1; l < pathPoints[k].length - 1; l++) { // Selects control point to modify
					
					var xForce = 0;
					var yForce = 0;
					var xEForce = 0;
					var yEForce = 0;
					var xSForce = 0;
					var ySForce = 0;
					var angleCompatibility = 0;
					var scaleCompatibility = 0;
					var positionCompatibility = 0;
					var visCompatibility = 0;
					var edgeCompatibility = 0;
					
					xDistance0 = pathPoints[k][l].x - pathPoints[k][l - 1].x;
					xDistance1 = pathPoints[k][l].x - pathPoints[k][l + 1].x;
					yDistance0 = pathPoints[k][l].y - pathPoints[k][l - 1].y;
					yDistance1 = pathPoints[k][l].y - pathPoints[k][l + 1].y;
					
					for (var m = 0; m < pathPoints.length; m++) { // Selects interacting path
						
						if (m != k) {
												
							//edgeKComponents = {x: Math.abs(pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x), y: Math.abs(pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y)};
							edgeMComponents = {x: Math.abs(pathPoints[m][0].x - pathPoints[m][pathPoints[m].length - 1].x), y: Math.abs(pathPoints[m][0].y - pathPoints[m][pathPoints[m].length - 1].y)};
							//edgeKLength = Math.sqrt(edgeKComponents.x * edgeKComponents.x + edgeKComponents.y * edgeKComponents.y);
							edgeMLength = Math.sqrt(edgeMComponents.x * edgeMComponents.x + edgeMComponents.y * edgeMComponents.y);					
							angleCompatibility = (edgeKComponents.x * edgeMComponents.x + edgeKComponents.y * edgeMComponents.y) / (edgeKLength * edgeMLength);
							
							averageLength = (edgeKLength + edgeMLength) / 2;
							scaleCompatibility = 2 / (averageLength * Math.min(edgeKLength, edgeMLength) + Math.max(edgeKLength, edgeMLength) / averageLength);
							scaleCompatibility = scaleCompatibility / (scaleCompatibility + 0.001);
							
							/*xKMin = Math.min(pathPoints[k][0].x, pathPoints[k][pathPoints[k].length - 1].x);
							xKMax = Math.max(pathPoints[k][0].x, pathPoints[k][pathPoints[k].length - 1].x);*/
							xMMin = Math.min(pathPoints[m][0].x, pathPoints[m][pathPoints[m].length - 1].x);
							xMMax = Math.max(pathPoints[m][0].x, pathPoints[m][pathPoints[m].length - 1].x);
							/*yKMin = Math.min(pathPoints[k][0].y, pathPoints[k][pathPoints[k].length - 1].y);
							yKMax = Math.max(pathPoints[k][0].y, pathPoints[k][pathPoints[k].length - 1].y);*/
							yMMin = Math.min(pathPoints[m][0].y, pathPoints[m][pathPoints[m].length - 1].y);
							yMMax = Math.max(pathPoints[m][0].y, pathPoints[m][pathPoints[m].length - 1].y);
							kMidpoint = {x: xKMin + (xKMax - xKMin) / 2, y: yKMin + (yKMax - yKMin) / 2};
							mMidpoint = {x: xMMin + (xMMax - xMMin) / 2, y: yMMin + (yMMax - yMMin) / 2};
							kMMidpointSeparation = Math.sqrt((kMidpoint.x - mMidpoint.x) * (kMidpoint.x - mMidpoint.x) + (kMidpoint.y - mMidpoint.y) * (kMidpoint.y - mMidpoint.y)); 
							positionCompatibility = averageLength / (averageLength + kMMidpointSeparation);
							
							
							mExtender0 = {x: 100 * (pathPoints[m][0].x - pathPoints[m][pathPoints[m].length - 1].x) + pathPoints[m][pathPoints[m].length - 1].x, y: 100 * (pathPoints[m][0].y - pathPoints[m][pathPoints[m].length - 1].y) + pathPoints[m][pathPoints[m].length - 1].y};
							mExtender1 = {x: 100 * (pathPoints[m][pathPoints[m].length - 1].x - pathPoints[m][0].x) + pathPoints[m][0].x, y: 100 * (pathPoints[m][pathPoints[m].length - 1].y - pathPoints[m][0].y) + pathPoints[m][0].y};
							kSightLine0 = [{x: 100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][0].x, y: 100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][0].y}, {x: -100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][0].x, y: -100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][0].y}];
							kSightLine1 = [{x: 100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][pathPoints[k].length - 1].x, y: 100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][pathPoints[k].length - 1].y}, {x: -100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][pathPoints[k].length - 1].x, y: -100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][pathPoints[k].length - 1].y}];
							
							if (Math.abs((mExtender0.x - mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x - kSightLine0[1].x)) > 0.001) {
							
								kOnMIntersection0 = {x: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine0[0].x - kSightLine0[1].x) - (mExtender0.x - mExtender1.x) * (kSightLine0[0].x * kSightLine0[1].y - kSightLine0[0].y * kSightLine0[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x - kSightLine0[1].x)), y: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x * kSightLine0[1].y - kSightLine0[0].y * kSightLine0[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x - kSightLine0[1].x))};
								kOnMIntersection1 = {x: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine1[0].x - kSightLine1[1].x) - (mExtender0.x - mExtender1.x) * (kSightLine1[0].x * kSightLine1[1].y - kSightLine1[0].y * kSightLine1[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine1[0].y - kSightLine1[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine1[0].x - kSightLine1[1].x)), y: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine1[0].y - kSightLine1[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine1[0].x * kSightLine1[1].y - kSightLine1[0].y * kSightLine1[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine1[0].y - kSightLine1[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine1[0].x - kSightLine1[1].x))};
								kOnMIntersectionMidpoint = {x: (kOnMIntersection0.x + kOnMIntersection1.x) / 2, y: (kOnMIntersection0.y + kOnMIntersection1.y) / 2};
								mMidpoint = {x: (pathPoints[m][0].x + pathPoints[m][pathPoints[m].length - 1].x) / 2, y: (pathPoints[m][0].y + pathPoints[m][pathPoints[m].length - 1].y) / 2};
								kOnMMidpointSeparation = Math.sqrt((kOnMIntersectionMidpoint.x - mMidpoint.x) * (kOnMIntersectionMidpoint.x - mMidpoint.x) + (kOnMIntersectionMidpoint.y - mMidpoint.y) * (kOnMIntersectionMidpoint.y - mMidpoint.y));
								visKOnM = Math.max(1 - 2 * kOnMMidpointSeparation / edgeMLength, 0);
								
							}
							
							else {
							
								visKOnM = 0;
								
							}
						
							var tempk = k;
							var tempm = m;
							
							m = tempk;
							k = tempm;
							
							mExtender0 = {x: 100 * (pathPoints[m][0].x - pathPoints[m][pathPoints[m].length - 1].x) + pathPoints[m][pathPoints[m].length - 1].x, y: 100 * (pathPoints[m][0].y - pathPoints[m][pathPoints[m].length - 1].y) + pathPoints[m][pathPoints[m].length - 1].y};
							mExtender1 = {x: 100 * (pathPoints[m][pathPoints[m].length - 1].x - pathPoints[m][0].x) + pathPoints[m][0].x, y: 100 * (pathPoints[m][pathPoints[m].length - 1].y - pathPoints[m][0].y) + pathPoints[m][0].y};
							/*kSightLine0 = [{x: 100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][0].x, y: 100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][0].y}, {x: -100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][0].x, y: -100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][0].y}];
							kSightLine1 = [{x: 100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][pathPoints[k].length - 1].x, y: 100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][pathPoints[k].length - 1].y}, {x: -100 * (pathPoints[k][0].y - pathPoints[k][pathPoints[k].length - 1].y) + pathPoints[k][pathPoints[k].length - 1].x, y: -100 * (pathPoints[k][0].x - pathPoints[k][pathPoints[k].length - 1].x) + pathPoints[k][pathPoints[k].length - 1].y}];*/
							
							if (Math.abs((mExtender0.x - mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x - kSightLine0[1].x)) > 0.001) {
							
								kOnMIntersection0 = {x: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine0[0].x - kSightLine0[1].x) - (mExtender0.x - mExtender1.x) * (kSightLine0[0].x * kSightLine0[1].y - kSightLine0[0].y * kSightLine0[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x - kSightLine0[1].x)), y: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x * kSightLine0[1].y - kSightLine0[0].y * kSightLine0[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine0[0].y - kSightLine0[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine0[0].x - kSightLine0[1].x))};
								kOnMIntersection1 = {x: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine1[0].x - kSightLine1[1].x) - (mExtender0.x - mExtender1.x) * (kSightLine1[0].x * kSightLine1[1].y - kSightLine1[0].y * kSightLine1[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine1[0].y - kSightLine1[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine1[0].x - kSightLine1[1].x)), y: ((mExtender0.x * mExtender1.y - mExtender0.y * mExtender1.x) * (kSightLine1[0].y - kSightLine1[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine1[0].x * kSightLine1[1].y - kSightLine1[0].y * kSightLine1[1].x)) / ((mExtender0.x - mExtender1.x) * (kSightLine1[0].y - kSightLine1[1].y) - (mExtender0.y - mExtender1.y) * (kSightLine1[0].x - kSightLine1[1].x))};
								kOnMIntersectionMidpoint = {x: (kOnMIntersection0.x + kOnMIntersection1.x) / 2, y: (kOnMIntersection0.y + kOnMIntersection1.y) / 2};
								mMidpoint = {x: (pathPoints[m][0].x + pathPoints[m][pathPoints[m].length - 1].x) / 2, y: (pathPoints[m][0].y + pathPoints[m][pathPoints[m].length - 1].y) / 2};
								kOnMMidpointSeparation = Math.sqrt((kOnMIntersectionMidpoint.x - mMidpoint.x) * (kOnMIntersectionMidpoint.x - mMidpoint.x) + (kOnMIntersectionMidpoint.y - mMidpoint.y) * (kOnMIntersectionMidpoint.y - mMidpoint.y));
								visMOnK = Math.max(1 - 2 * kOnMMidpointSeparation / edgeMLength, 0);
								
							}
							
							else {
							
								visMOnK = 0;
								
							}
							
							k = tempk;
							m = tempm;
							
							visCompatibility = Math.max(visMOnK, visKOnM);
							
							edgeCompatibility = 1;
							
							edgeCompatibility = angleCompatibility * scaleCompatibility * positionCompatibility/* * visCompatibility*/;
							
							if (edgeCompatibility >= compatibilityThreshold) {
								
								k0 = {x: pathPoints[k][0].x, y: pathPoints[k][0].y};
								k1 = {x: pathPoints[k][pathPoints[k].length - 1].x, y: pathPoints[k][pathPoints[k].length - 1].y};
								m0 = {x: pathPoints[m][0].x, y: pathPoints[m][0].y};
								m1 = {x: pathPoints[m][pathPoints[m].length - 1].x, y: pathPoints[m][pathPoints[m].length - 1].y};
								
								x12 = k0.x - m1.x;
								x34 = m0.x - k1.x;
								y12 = k0.y - m1.y;
								y34 = m0.y - k1.y;
								
								if (x12 * y34 - y12 * x34 != 0) {
									
									pointOfIntersection = {x: ((k0.x * m1.y - k0.y * m1.x) * x34 - x12 * (m0.x * k1.y - m0.y * k1.x)) / (x12 * y34 - y12 * x34), y: ((k0.x * m1.y - k0.y * m1.x) * y34 - y12 * (m0.x * k1.y - m0.y * k1.x)) / (x12 * y34 - y12 * x34)};
														
									if (Math.min(k0.x, m1.x) <= pointOfIntersection.x && pointOfIntersection.x <= Math.max(k0.x, m1.x) && Math.min(k0.y, m1.y) <= pointOfIntersection.y && pointOfIntersection.y <= Math.max(k0.y, m1.y) && Math.min(m0.x, k1.x) <= pointOfIntersection.x && pointOfIntersection.x <= Math.max(m0.x, k1.x) && Math.min(m0.y, k1.y) <= pointOfIntersection.y && pointOfIntersection.y <= Math.max(m0.y, k1.y)) {
									
										xDistance = pathPoints[k][l].x - pathPoints[m][l].x + 0.00001;
										yDistance = pathPoints[k][l].y - pathPoints[m][l].y + 0.00001;
										distance = Math.sqrt(xDistance * xDistance + yDistance * yDistance) + 0.000001;
										eForce = 1 / Math.abs(distance);
										xEForce = xEForce + edgeCompatibility / (eForce * xDistance / distance);
										yEForce = yEForce + edgeCompatibility / (eForce * yDistance / distance);
										
									}
									
									else {
							
										xDistance = pathPoints[k][l].x - pathPoints[m][pathPoints[m].length - (l + 1)].x + 0.000001;
										yDistance = pathPoints[k][l].y - pathPoints[m][pathPoints[m].length - (l + 1)].y + 0.000001;
										distance = Math.sqrt(xDistance * xDistance + yDistance * yDistance) + 0.000001;
										eForce = 1 / Math.abs(distance);
										xEForce = xEForce + edgeCompatibility / (eForce * xDistance / distance);
										yEForce = yEForce + edgeCompatibility / (eForce * yDistance / distance);
									
									}
								}
								
								else {
							
									xDistance = pathPoints[k][l].x - pathPoints[m][pathPoints[m].length - (l + 1)].x + 0.000001;
									yDistance = pathPoints[k][l].y - pathPoints[m][pathPoints[m].length - (l + 1)].y + 0.000001;
									distance = Math.sqrt(xDistance * xDistance + yDistance * yDistance) + 0.000001;
									eForce = 1 / (distance);
									xEForce = xEForce + edgeCompatibility / (eForce * xDistance / distance);
									yEForce = yEForce + edgeCompatibility / (eForce * yDistance / distance);
									
								}
							}
						}
					}
					
					distance0 = Math.sqrt(xDistance0 * xDistance0 + yDistance0 * yDistance0) + 0.000001;
					distance1 = Math.sqrt(xDistance1 * xDistance1 + yDistance1 * yDistance1) + 0.000001;
					kP = K / ((edgeKLength) * (controlPoints + 1)); 
					sForce0 = -kP * distance0;
					sForce1 = -kP * distance1;
					sForce = sForce0 + sForce1;
					xSForce = sForce * ((xDistance0 / distance0) + (xDistance1 / distance1));
					ySForce = sForce * ((yDistance0 / distance0) + (yDistance1 / distance1));
					xForce = xSForce - xEForce;
					yForce = ySForce - yEForce;
					force = Math.sqrt(xForce * xForce + yForce * yForce) + 0.00001;
					
					if (force == 0) {
					
						xMove = 0;
						yMove = 0;
						
					}
					
					else {
					
						xMove = stepSize * (xForce / force);
						yMove = stepSize * (yForce / force);
						
					}
					
					tempXLocation = [pathPoints[k][l].x];
					tempYLocation = [pathPoints[k][l].y];
					tempXLocation = tempXLocation.slice(0);
					tempYLocation = tempYLocation.slice(0);
					newPositions[k][l].x = tempXLocation[0] + xMove;
					newPositions[k][l].y = tempYLocation[0] + yMove;
					
				}
				
			}
			
			pathPoints = $.extend(true, [], newPositions);
			
		}
		
	}
	
	var width = 300,
		height = 300;
	
	var svg = d3.select("svg").append("svg")
		.attr("width", width)
		.attr("height", height);

	var thickness = 2;

	for (var i = 0; i < edges.length; i++) {	
			
		var line = d3.svg.line()
			.x(function(d) {return d.x;})
			.y(function(d) {return d.y;})
			.interpolate("bundle")
			.tension(tension);
		
		if (edges[i].length == 2) {
			
			thickness = 1;
			
		} else {
		
			thickness = edges[i][2];
		
		}
		
		/*svg.append("path")
			.attr("d", line(pathPoints[i]))
			.style("stroke", color)
			.style("stroke-width", 1.5)
			.style("fill", "none");*/
			
		svg.append("path")
			.attr("d", line(pathPoints[i]))
			.attr("stroke", color)
			.attr("stroke-width", 1)
			.attr("fill", "none");
            //.attr("marker-end", "url(#arrowhead)");
		
		//var color = d3.interpolateLab("#008000", "#c83a22");
		
		/*var line = d3.svg.line()
			.interpolate("basis");*/
/*
		var points = pathPoints[i];
		
		svg.selectAll("path")
			.data(quad(sample(line(points), 8)))
		  .enter().append("path")
			.style("fill", function(d) { return color(d.t); })
			.style("stroke", function(d) { return color(d.t); })
			.attr("d", function(d) { return lineJoin(d[0], d[1], d[2], d[3], 32); });
		
		// Sample the SVG path string "d" uniformly with the specified precision.
		function sample(d, precision) {
		  var path = document.createElementNS(d3.ns.prefix.svg, "path");
		  path.setAttribute("d", d);
		
		  var n = path.getTotalLength(), t = [0], i = 0, dt = precision;
		  while ((i += dt) < n) t.push(i);
		  t.push(n);
		
		  return t.map(function(t) {
			var p = path.getPointAtLength(t), a = [p.x, p.y];
			a.t = t / n;
			return a;
		  });
		}
		
		// Compute quads of adjacent points [p0, p1, p2, p3].
		function quad(points) {
		  return d3.range(points.length - 1).map(function(i) {
			var a = [points[i - 1], points[i], points[i + 1], points[i + 2]];
			a.t = (points[i].t + points[i + 1].t) / 2;
			return a;
		  });
		}
		
		// Compute stroke outline for segment p12.
		function lineJoin(p0, p1, p2, p3, width) {
		  var u12 = perp(p1, p2),
			  r = width / 2,
			  a = [p1[0] + u12[0] * r, p1[1] + u12[1] * r],
			  b = [p2[0] + u12[0] * r, p2[1] + u12[1] * r],
			  c = [p2[0] - u12[0] * r, p2[1] - u12[1] * r],
			  d = [p1[0] - u12[0] * r, p1[1] - u12[1] * r];
		
		  if (p0) { // clip ad and dc using average of u01 and u12
			var u01 = perp(p0, p1), e = [p1[0] + u01[0] + u12[0], p1[1] + u01[1] + u12[1]];
			a = lineIntersect(p1, e, a, b);
			d = lineIntersect(p1, e, d, c);
		  }
		
		  if (p3) { // clip ab and dc using average of u12 and u23
			var u23 = perp(p2, p3), e = [p2[0] + u23[0] + u12[0], p2[1] + u23[1] + u12[1]];
			b = lineIntersect(p2, e, a, b);
			c = lineIntersect(p2, e, d, c);
		  }
		
		  return "M" + a + "L" + b + " " + c + " " + d + "Z";
		}
		
		// Compute intersection of two infinite lines ab and cd.
		function lineIntersect(a, b, c, d) {
		  var x1 = c[0], x3 = a[0], x21 = d[0] - x1, x43 = b[0] - x3,
			  y1 = c[1], y3 = a[1], y21 = d[1] - y1, y43 = b[1] - y3,
			  ua = (x43 * (y1 - y3) - y43 * (x1 - x3)) / (y43 * x21 - x43 * y21);
		  return [x1 + ua * x21, y1 + ua * y21];
		}
		
		// Compute unit vector perpendicular to p01.
		function perp(p0, p1) {
		  var u01x = p0[1] - p1[1], u01y = p1[0] - p0[0],
			  u01d = Math.sqrt(u01x * u01x + u01y * u01y);
		  return [u01x / u01d, u01y / u01d];
		}*/
			
	}
		
}
