function pyramid(base, colorscheme) {
	
	d3.json("newpyramid.json", function(testjsonobject) {
		
		var brodmannConnectivity = testjsonobject.array;
	
		var height = base;
		
		function roundnumber(num) {
		
			var result = Math.round(num * Math.pow(10, 1)) / Math.pow(10, 1);
			return result;
		
		}
		
		var averageStrengths = [[], [0, 0, 0, 0, 0, 0]];
		
		for (var i = 1; i < 53; i++) {
			
			var sum = 0;
			var n = 0;
			
			for (var j = 0; j < brodmannConnectivity.length; j++) {
			
				if (brodmannConnectivity[j][0] === i) {
					
					sum = sum + brodmannConnectivity[j][2];
					n = n + 1;
					
				}
				
			}
			
			if (n === 0) {
			
				n = 1;
				
			}
			
			if (sum / n > Math.min.apply(0, averageStrengths[1])) { 
				
				averageStrengths[0][averageStrengths[1].indexOf(Math.min.apply(null, averageStrengths[1]))] = i;
				averageStrengths[1][averageStrengths[1].indexOf(Math.min.apply(null, averageStrengths[1]))] = roundnumber(sum / n);
			
			}
			
		}
		
		// size of circle is average strength
		// color of circle is brodmann area
		// width of connection is average strength of connections between
		
		// circle [ brodmann identity, color, strength ]
		
		if (colorscheme === "blue") {
		
			var colorone = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
			var colortwo = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
			var colorthree = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
			var colorfour = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
			var colorfive = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
			var colorsix = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
			
		}
		
		if (colorscheme === "vanilla") {
			
			var colorone = "rgb(255, 255, 255)";
			var colortwo = "rgb(255, 255, 255)";
			var colorthree = "rgb(234, 173, 40)";
			var colorfour = "rgb(215, 171, 108)";
			var colorfive = "rgb(127, 133, 35)";
			var colorsix = "rgb(251, 235, 215)";
			
		}
		
		if (colorscheme === "summer") {
			
			var colorone = "rgb(255, 253, 238)";
			var colortwo = "rgb(254, 251, 182)";
			var colorthree = "rgb(210, 230, 161)";
			var colorfour = "rgb(122, 189, 158)";
			var colorfive = "rgb(65, 119, 129)";
			var colorsix = "rgb(161, 190, 232)";
			
		}
		
		if (colorscheme === "olive") {
			
			var colorone = "rgb(129, 131, 31)";
			var colortwo = "rgb(6, 136, 63)";
			var colorthree = "rgb(129, 131, 31)";
			var colorfour = "rgb(251, 235, 215)";
			var colorfive = "rgb(6, 134, 63)";
			var colorsix = "rgb(233, 174, 43)";
			
		}
		
		var one = [averageStrengths[0][0], colorone, averageStrengths[1][0]];					
		var two = [averageStrengths[0][1], colortwo, averageStrengths[1][1]];
		var three = [averageStrengths[0][2], colorthree, averageStrengths[1][2]];
		var four = [averageStrengths[0][3], colorfour, averageStrengths[1][3]];
		var five = [averageStrengths[0][4], colorfive, averageStrengths[1][4]];
		var six = [averageStrengths[0][5], colorsix, averageStrengths[1][5]];
		
		var w = base;
		var h = height;
		
		var svg = d3.select("body")
					.append("svg")
					.attr("width", 1000)
					.attr("height", 1000);
					
		var pyr = d3.select("svg")
					.append("svg")
					.attr("width", base)
					.attr("height", height)
					.attr("x", base / 9)
					.attr("y", base / 9);
		
		function drawpyramid(x, y, base, height) {
			
			var triangle = [[x, y], [x - base / 2, y + height], [x + base / 2, y + height], [x, y]];
			var topsegment = [[x - base / 6, y + height / 3], [x + base / 6, y + height / 3]];
			var bottomsegment = [[x - base / 3, y + 2 * height / 3], [x + base / 3, y + 2 * height / 3]];
			
			var line = d3.svg.line()
				.x(function(d) {return d[0];})
				.y(function(d) {return d[1];});
			
			pyr.append("path")
				.attr("d", line(triangle))
				.attr("fill", "rgb(245, 245, 245)")
				.attr("stroke", "rgb(200, 200, 200)")
				.attr("stroke-width", "1.5");
				
			pyr.append("path")
				.attr("d", line(topsegment))
				.attr("fill", "none")
				.attr("stroke", "rgb(200, 200, 200)")
				.attr("stroke-width", "3");
				
			pyr.append("path")
				.attr("d", line(bottomsegment))
				.attr("fill", "none")
				.attr("stroke", "rgb(200, 200, 200)")
				.attr("stroke-width", "3");
			
		}
		
		drawpyramid(base / 2, 0, base, base * 2 / 3);
		
		function drawcircle(x, y, number) {
			
			pyr.append("circle")
				.attr("fill", number[1])
				.attr("r", number[2] * (base / 70) / 30 + 2)
				.attr("cx", x)
				.attr("cy", y)
				.attr("stroke", "grey")
				.attr("stroke-width", 1);
		
		}
		
		drawcircle(base * 0.5, height * 0.068, one);
		drawcircle(base * 0.462, height * 0.125, two);
		drawcircle(base * 0.537, height * 0.125, three);
		drawcircle(base * 0.424, height * 0.179, four);
		drawcircle(base * 0.5, height * 0.179, five);
		drawcircle(base * 0.574, height * 0.179, six);

		pyr.append("text")
			.text(one[0])
			.attr("x", base * 0.5025 - base / 150 - (one[0].toString().length - 1) * (base / 55) / 4)
			.attr("y", base * 0.069 - base / 40)
			.attr("font-family", "arial")
			.attr("font-size", base / 55);
			
		pyr.append("text")
			.text(two[0])
			.attr("x", base * 0.468 - base / 150 - (two[0].toString().length - 1) * (base / 55) / 4)
			.attr("y", base * 0.126 - base / 40)
			.attr("font-family", "arial")
			.attr("font-size", base / 55);
			
		pyr.append("text")
			.text(three[0])
			.attr("x", base * 0.533 - base / 150 - (three[0].toString().length - 1) * (base / 55) / 4)
			.attr("y", base * 0.127 - base / 40)
			.attr("font-family", "arial")
			.attr("font-size", base / 55);
			
		pyr.append("text")
			.text(four[0])
			.attr("x", base * 0.428 - base / 150 - (four[0].toString().length - 1) * (base / 55) / 4)
			.attr("y", base * 0.182 - base / 40)
			.attr("font-family", "arial")
			.attr("font-size", base / 55);
			
		pyr.append("text")
			.text(five[0])
			.attr("x", base * 0.5022 - base / 150 - (five[0].toString().length - 1) * (base / 55) / 4)
			.attr("y", base * 0.181 - base / 40)
			.attr("font-family", "arial")
			.attr("font-size", base / 55);
			
		pyr.append("text")
			.text(six[0])
			.attr("x", base * 0.568 - base / 150 - (six[0].toString().length - 1) * (base / 55) / 4)
			.attr("y", base * 0.181 - base / 40)
			.attr("font-family", "arial")
			.attr("font-size", base / 55);
		
		function drawpair(x, y, top) {
			
			var possiblePairs = [one, two, three, four, five, six];
			var pairStrength = 0;
			
			for (var i = 0; i < 6; i++) {
				
				if (possiblePairs[i][0] != top[0]) {
				
					for (var j = 0; j < brodmannConnectivity.length; j++) {
						
						var sum = 0;
						var n = 0;
					
						if (brodmannConnectivity[j][0] === top[0] && brodmannConnectivity[j][1] === possiblePairs[i][0]) {
							
							sum = sum + brodmannConnectivity[j][2];
							n = n + 1;
							
						}
						
					}
					
					if (n === 0) {
						
						n = 1;
							
					}
					
					if (sum / n >= pairStrength) {
						
						pair = possiblePairs[i];
						pairStrength = sum / n;
					
					}
				
				}
				
			}
			
			var strength = 0;
			var n = 1;
			
			for (var i = 1; i < brodmannConnectivity.length + 1; i++) {
				
				if (brodmannConnectivity[i - 1][0] === top[0] && brodmannConnectivity[i - 1][1] === pair[0]) {
				
					strength = (brodmannConnectivity[i - 1][2] + strength * (n - 1)) / n;
					n = n + 1;
					
				}
				
			}
			
			var path = [[x, y], [x, y + height * 0.1]];
			
			var line = d3.svg.line()
				.x(function(d) {return d[0];})
				.y(function(d) {return d[1];});
			
			pyr.append("path")
				.attr("d", line(path))
				.attr("stroke", "white")
				.attr("stroke-width", base / 30)
				.attr("fill", "none");
				
			pyr.append("circle")
				.attr("r", base / 38)
				.attr("cx", x)
				.attr("cy", y)
				.attr("fill", "white");
				
			pyr.append("circle")
				.attr("r", base / 38)
				.attr("cx", x)
				.attr("cy", y + height * 0.1)
				.attr("fill", "white");
				
			var sharedpath = [[x, y], [x, y + height * 0.1]];
			
			pyr.append("path")
				.attr("d", line(sharedpath))
				.attr("stroke", "lightgrey")
				.attr("stroke-width", strength / 4 + 0.5)
				.attr("fill", "none");
			
			drawcircle(x, y, top);
			drawcircle(x, y + height * 0.1, pair);
			
			pyr.append("text")
				.text(top[0])
				.attr("font-family", "arial")
				.attr("font-size", base / 55)
				.attr("x", x - base / 200 - (top[0].toString().length - 1) * (base / 55) / 4)
				.attr("y", y - base / 33);
				
			pyr.append("text")
				.text(pair[0])
				.attr("font-family", "arial")
				.attr("font-size", base / 55)
				.attr("x", x - base / 200 - (pair[0].toString().length - 1) * (base / 55) / 4)
				.attr("y", y + base / 7);
			
		}
		
		drawpair(base * 0.335, height * 0.29, one);
		drawpair(base * 0.4, height * 0.29, two);
		drawpair(base * 0.465, height * 0.29, three);
		drawpair(base * 0.53, height * 0.29, four);
		drawpair(base * 0.595, height * 0.29, five);
		drawpair(base * 0.66, height * 0.29, six);
		
		function drawtriplet(x, y, top) {
			
			var possibleLefts = [one, two, three, four, five, six];
			var pairStrength = 0;
			
			for (var i = 0; i < 6; i++) {
				
				if (possibleLefts[i][0] != top[0]) {
				
					for (var j = 0; j < brodmannConnectivity.length; j++) {
						
						var sum = 0;
						var n = 0;
					
						if (brodmannConnectivity[j][0] === top[0] && brodmannConnectivity[j][1] === possibleLefts[i][0]) {
							
							sum = sum + brodmannConnectivity[j][2];
							n = n + 1;
							
						}
						
					}
					
					if (n === 0) {
						
						n = 1;
							
					}
					
					if (sum / n >= pairStrength) {
						
						left = possibleLefts[i];
						pairStrength = sum / n;
					
					}
				
				}
				
			}
			
			var possibleRights = [one, two, three, four, five, six];
			var pairStrength = 0;
			
			for (var i = 0; i < 6; i++) {
				
				if (possibleRights[i][0] != top[0] && possibleRights[i][0] != left[0]) {
				
					for (var j = 0; j < brodmannConnectivity.length; j++) {
						
						var sum = 0;
						var n = 0;
					
						if (brodmannConnectivity[j][0] === top[0] && brodmannConnectivity[j][1] === possibleRights[i][0]) {
							
							sum = sum + brodmannConnectivity[j][2];
							n = n + 1;
							
						}
						
					}
					
					if (n === 0) {
						
						n = 1;
							
					}
					
					if (sum / n >= pairStrength) {
						
						right = possibleRights[i];
						pairStrength = sum / n;
					
					}
				
				}
				
			}
			
			var tLStrength = 0;
			var n = 1;
			
			for (var i = 1; i < brodmannConnectivity.length + 1; i++) {
				
				if (brodmannConnectivity[i - 1][0] === top[0] && brodmannConnectivity[i - 1][1] === left[0]) {
				
					tLStrength = (brodmannConnectivity[i - 1][2] + tLStrength * (n - 1)) / n;
					n = n + 1;
					
				}
				
			}
			
			var tRStrength = 0;
			var n = 1;
			
			for (var i = 1; i < brodmannConnectivity.length + 1; i++) {
				
				if (brodmannConnectivity[i - 1][0] === top[0] && brodmannConnectivity[i - 1][1] === right[0]) {
				
					tRStrength = (brodmannConnectivity[i - 1][2] + tRStrength * (n - 1)) / n;
					n = n + 1;
					
				}
				
			}
			
			var lRStrength = 0;
			var n = 1;
			
			for (var i = 1; i < brodmannConnectivity.length + 1; i++) {
				
				if (brodmannConnectivity[i - 1][0] === left[0] && brodmannConnectivity[i - 1][1] === right[0]) {
				
					lRStrength = (brodmannConnectivity[i - 1][2] + lRStrength * (n - 1)) / n;
					n = n + 1;
					
				}
				
			}
			
			var rLStrength = 0;
			var n = 1;
			
			for (var i = 1; i < brodmannConnectivity.length + 1; i++) {
				
				if (brodmannConnectivity[i - 1][0] === left[0] && brodmannConnectivity[i - 1][1] === right[0]) {
				
					lRStrength = (brodmannConnectivity[i - 1][2] + lRStrength * (n - 1)) / n;
					n = n + 1;
					
				}
				
			}	
			
			var lRRLStrength = (rLStrength + lRStrength) / 2
			
			var path = [[x, y], [x - base / 30, y + base / 10.5], [x + base / 30, y + base / 10.5], [x, y]];
			
			var line = d3.svg.line()
				.x(function(d) {return d[0];})
				.y(function(d) {return d[1];});
			
			pyr.append("path")
				.attr("d", line(path))
				.attr("stroke", "white")
				.attr("stroke-width", base / 30)
				.attr("fill", "none");
				
			pyr.append("circle")
				.attr("r", base / 38)
				.attr("cx", x)
				.attr("cy", y)
				.attr("fill", "white");
				
			pyr.append("circle")
				.attr("r", base / 38)
				.attr("cx", x - base / 30)
				.attr("cy", y + base / 10.5)
				.attr("fill", "white");
				
			pyr.append("circle")
				.attr("r", base / 38)
				.attr("cx", x + base / 30)
				.attr("cy",  y + base / 10.5)
				.attr("fill", "white");
				
			var shared12path = [[x, y], [x - base / 30, y + base / 10.5]];
			var shared23path = [[x - base / 30, y + base / 10.5], [x + base / 30, y + base / 10.5]];
			var shared31path = [[x + base / 30, y + base / 10.5], [x, y]];
			
			pyr.append("path")
				.attr("d", line(shared12path))
				.attr("stroke", "lightgrey")
				.attr("stroke-width", tLStrength / 4 + 0.5)
				.attr("fill", "none");
				
			pyr.append("path")
				.attr("d", line(shared23path))
				.attr("stroke", "lightgrey")
				.attr("stroke-width", lRRLStrength / 4 + 0.5)
				.attr("fill", "none");
				
			pyr.append("path")
				.attr("d", line(shared31path))
				.attr("stroke", "lightgrey")
				.attr("stroke-width", tRStrength / 4 + 0.5)
				.attr("fill", "none");
			
			drawcircle(x, y, top);
			drawcircle(x - base / 30, y + base / 10.5, left);
			drawcircle(x + base / 30, y + base / 10.5, right);
			
			pyr.append("text")
				.text(top[0])
				.attr("font-family", "arial")
				.attr("font-size", base / 55)
				.attr("x", x - base / 200 - (top[0].toString().length - 1) * (base / 55) / 4)
				.attr("y", y - base / 33);
				
			pyr.append("text")
				.text(left[0])
				.attr("font-family", "arial")
				.attr("font-size", base / 55)
				.attr("x", x - base / 30 - base / 200 - (left[0].toString().length) * (base / 55) / 4)
				.attr("y", y + base / 7.25);
				
			pyr.append("text")
				.text(right[0])
				.attr("font-family", "arial")
				.attr("font-size", base / 55)
				.attr("x", x + base / 30 + base / 200 - (right[0].toString().length) * (base / 55) / 4)
				.attr("y", y + base / 7.25);
			
		}
		
		drawtriplet(base * 0.174, height * 0.5, one);
		drawtriplet(base * 0.304, height * 0.5, two);
		drawtriplet(base * 0.434, height * 0.5, three);
		drawtriplet(base * 0.564, height * 0.5, four); 
		drawtriplet(base * 0.694, height * 0.5, five);
		drawtriplet(base * 0.824, height * 0.5, six);
		
		drawcircle(base / 24, base / 9, one);
		drawcircle(base / 24, base / 40 + base / 9 + 2 * base / 80, two);
		drawcircle(base / 24, base / 20 + base / 9 + 4 * base / 80, three);
		drawcircle(base / 24, base / 13.333 + base / 9 + 6 * base / 80, four);
		drawcircle(base / 24, base / 10 + base / 9 + 8 * base / 80, five);
		drawcircle(base / 24, base / 8 + base / 9 + 10 * base / 80, six);
		
		svg.append("text")
			.text("Brodmann Area &")
			.attr("font-family", "arial")
			.attr("font-size", base / 40)
			.attr("x", base / 12)
			.attr("y", base / 6.4)
			
		svg.append("text")
			.text("Average Significance of Causality")
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 30)
			.attr("y", base / 5.4)
		
		// Identities
		
		svg.append("text")
			.text(averageStrengths[0][0])
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 10)
			.attr("y", base / 9 + base / 9 + base / 200)
			
		svg.append("text")
			.text(averageStrengths[0][1])
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 10)
			.attr("y", base / 9 + base / 40 + base / 9 + 2 * base / 80 + base / 200)
			
		svg.append("text")
			.text(averageStrengths[0][2])
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 10)
			.attr("y", base / 9 + base / 20 + base / 9 + 4 * base / 80 + base / 200)
			
		svg.append("text")
			.text(averageStrengths[0][3])
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 10)
			.attr("y", base / 9 + base / 13.333 + base / 9 + 6 * base / 80 + base / 200)
			
		svg.append("text")
			.text(averageStrengths[0][4])
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 10)
			.attr("y", base / 9 + base / 10 + base / 9 + 8 * base / 80 + base / 200)
			
		svg.append("text")
			.text(averageStrengths[0][5])
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 10)
			.attr("y", base / 9 + base / 8 + base / 9 + 10 * base / 80 + base / 200)
		
		// Strengths
		
		svg.append("text")
			.text(roundnumber(one[2]))
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 5)
			.attr("y", base / 9 + base / 9 + base / 200);
			
		svg.append("line")
			.attr("x1", base / 5.55)
			.attr("x2", base / 5.25)
			.attr("y1", base / 9 + base / 9)
			.attr("y2", base / 9 + base / 9)
			.attr("stroke", "black")
			.attr("stroke-width", 1);
			
		svg.append("text")
			.text(roundnumber(two[2]))
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 5)
			.attr("y", base / 9 + base / 40 + base / 9 + 2 * base / 80 + base / 200);
			
		svg.append("line")
			.attr("x1", base / 5.55)
			.attr("x2", base / 5.25)
			.attr("y1", base / 9 + base / 40 + base / 9 + 2 * base / 80)
			.attr("y2", base / 9 + base / 40 + base / 9 + 2 * base / 80)
			.attr("stroke", "black")
			.attr("stroke-width", 1);
			
		svg.append("text")
			.text(roundnumber(three[2]))
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 5)
			.attr("y", base / 9 + base / 20 + base / 9 + 4 * base / 80 + base / 200);
			
		svg.append("line")
			.attr("x1", base / 5.55)
			.attr("x2", base / 5.25)
			.attr("y1", base / 9 + base / 20 + base / 9 + 4 * base / 80)
			.attr("y2", base / 9 + base / 20 + base / 9 + 4 * base / 80)
			.attr("stroke", "black")
			.attr("stroke-width", 1);
			
		svg.append("text")
			.text(roundnumber(four[2]))
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 5)
			.attr("y", base / 9 + base / 13.333 + base / 9 + 6 * base / 80 + base / 200);
			
		svg.append("line")
			.attr("x1", base / 5.55)
			.attr("x2", base / 5.25)
			.attr("y1", base / 9 + base / 13.333 + base / 9 + 6 * base / 80)
			.attr("y2", base / 9 + base / 13.333 + base / 9 + 6 * base / 80)
			.attr("stroke", "black")
			.attr("stroke-width", 1);
			
		svg.append("text")
			.text(roundnumber(five[2]))
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 5)
			.attr("y", base / 9 + base / 10 + base / 9 + 8 * base / 80 + base / 200);
			
		svg.append("line")
			.attr("x1", base / 5.55)
			.attr("x2", base / 5.25)
			.attr("y1", base / 9 + base / 10 + base / 9 + 8 * base / 80)
			.attr("y2", base / 9 + base / 10 + base / 9 + 8 * base / 80)
			.attr("stroke", "black")
			.attr("stroke-width", 1);
			
		svg.append("text")
			.text(roundnumber(six[2]))
			.attr("font-family", "arial")
			.attr("font-size", base / 50)
			.attr("x", base / 5)
			.attr("y", base / 9 + base / 8 + base / 9 + 10 * base / 80 + base / 200);
			
		svg.append("line")
			.attr("x1", base / 5.55)
			.attr("x2", base / 5.25)
			.attr("y1", base / 9 + base / 8 + base / 9 + 10 * base / 80)
			.attr("y2", base / 9 + base / 8 + base / 9 + 10 * base / 80)
			.attr("stroke", "black")
			.attr("stroke-width", 1);
		
		svg.append("text")
			.text("Significance of Causality")
			.attr("font-family", "arial")
			.attr("font-size", base / 40)
			.attr("x", base / 1.07)
			.attr("y", base / 5.25);
			
		svg.append("text")
			.text("30")
			.attr("font-family", "arial")
			.attr("font-size", base / 55)
			.attr("x", base + base / 10)
			.attr("y", base / 4.5 +  base / 100);
			
		svg.append("text")
			.text("15")
			.attr("font-family", "arial")
			.attr("font-size", base / 55)
			.attr("x", base + base / 10)
			.attr("y", base / 4.5 + base / 30 + base / 100);
	
		svg.append("text")
			.text("5")
			.attr("font-family", "arial")
			.attr("font-size", base / 55)
			.attr("x", base + base / 10)
			.attr("y", base / 4.5 + 2 * base / 30 + base / 150);
		
		svg.append("rect")
			.attr("x", base)
			.attr("y", base / 4.5)
			.attr("height", base / 75)
			.attr("width", base / 12.77)
			.attr("fill", "grey");
			
		svg.append("rect")
			.attr("x", base)
			.attr("y", base / 4.5 + base / 30)
			.attr("height", base / 141.2)
			.attr("width", base / 12.77)
			.attr("fill", "grey");
			
		svg.append("rect")
			.attr("x", base)
			.attr("y", base / 4.5 + 2 * base / 30)
			.attr("height", base / 342.9)
			.attr("width", base / 12.77)
			.attr("fill", "grey");
	
	});
	
}