function projectedArrows = drawdtfconngraph2(roiPos, val, ArSzLt, cortex, projected, bundled)

ArrowSizeLimit = ArSzLt;
valmin = min(val);
valmax = max(val);

%cmap = winter(64); 
cmap         = zeros(256,3);
%cmap(:,2)    = 1/256:(1/256):1;
%cmap(:,1)    = 1/256:(1/256):1;
cmap(:,3)    = ones(256,1).*0.8;


%R = [ones(32,1)*0.7; linspace(0.7,0.7,32).'];
%G = [ones(32,1)*0.7; linspace(0.7,0.7,32).'];
%B = [ones(32,1)*0.7; linspace(0,1,32).'];

%cmap = [R G B];

cnum = size(cmap,1);
maxmin = valmax-valmin;
if (maxmin == 0)
    maxmin = 1e-6;
end

hold on;
%col = cmap(1,:);

S = 16; %number of segments in each edge, sometimes fewer is better with edge bundling
allArrows = [];

for rr=[1:size(roiPos,1)]
    normVal=(val(rr) - valmin)/maxmin;
    normVal = min(max(0, normVal), 1);
    siz = ArrowSizeLimit(1) + diff(ArrowSizeLimit) * normVal;    
    colidx = round(normVal*(cnum-1)+1);
    col = cmap(colidx,:);
    [arcH arwH arrows]=drawpipe(roiPos(rr, 1:3), roiPos(rr, 4:6), siz, cortex, projected, bundled, S); % from output 'cc' to input 'rr'
    set([arcH; arwH], 'faceColor', col);
    allArrows = [allArrows; arrows];
end

if projected
    projectedArrows = allArrows;
end

%edge bundle arrows if desired by user
if bundled
    %TODO: write 3d edge bundling algorithm
    bundledEdges = edgebundle(allArrows, S); %replaces unbundled arrows with bundled arrows
    for i = 1:length(bundledEdges)/S %draws bundled arrows
        drawedgebundledarrows(bundledEdges((S*(i - 1) + 1):S*i, :));
    end
end

function [pipeH, arrowH, arrows]=drawpipe(A, B, radius, cortex, projected, bundled, S)
X_=1; Y_=2; Z_=3;
%if nargin < 4
opt=struct( ...
   'Radius', 10, ...
   'Color', 'blue', ...
   'PrismSides', S, ...
   'DrawMode', 'WHOLE', ... % 'WHOLE' 'HALF' 'DISPLACED'...
   'AspectRatio', 1, ...
   'ArrowType', 'MIDDLE', ...% 'NONE' 'END'
   ...
   'ArchType', 'HALFCIRCLE', ... % 'TEST' 'STREIGHT' 'HALFCIRCLE' 'ARCH' 
   'PipeSegments', S ...
   );
%end% if
if projected
    opt.ArchType = 'ARCH';
end
if nargin>2 & ~isempty(radius)
   opt.Radius=radius;
end% if
switch opt.ArchType
   case 'TEST'
%       edges=[
%          -80 30 0
%          -80 0 30
%          -80 0 0;
%          -100 0 0
%          -100 30 2
%          -100 0 30
%       ];
   case 'STREIGHT'
      edges=[A; B];
   case 'HALFCIRCLE'
      edges=zeros([opt.PipeSegments 3]);
      segmLen=norm(B-A);
      t_dir=(B-A)./segmLen;
%      z_dir=[0 0 1];
      z_dir = (A+B)/2;
      z_dir = z_dir/norm(z_dir);
      z_dir = z_dir + [0 0 2];
      z_dir = z_dir/norm(z_dir);
      phi=linspace(pi/2, 0, opt.PipeSegments)';
      rho=segmLen.*cos(phi);
      edges(:, X_) = A(X_) + rho .*(z_dir(X_).*sin(phi) + t_dir(X_).*cos(phi));
      edges(:, Y_) = A(Y_) + rho .*(z_dir(Y_).*sin(phi) + t_dir(Y_).*cos(phi));
      edges(:, Z_) = A(Z_) + rho .*(z_dir(Z_).*sin(phi) + t_dir(Z_).*cos(phi));
      arrows = edges;
   case 'ARCH'
        projectEdges = 1;
        if projectEdges
            %S = 50; %number of segments
            edges = zeros(S, 3);
            edgeDisplacement = B - A;
            edges(:, 1) = A(1) +  (0:(S - 1)) * edgeDisplacement(1)/(S - 1);
            edges(:, 2) = A(2) +  (0:(S - 1)) * edgeDisplacement(2)/(S - 1);
            edges(:, 3) = A(3) +  (0:(S - 1)) * edgeDisplacement(3)/(S - 1);
            edges.electrodes = edges;
            edges = projectElectrodes2(cortex, edges, 25);
            arrows = edges.trielectrodes;
        end
end% switch

if ~bundled

    radius=[];
    [pipes arrow]=pipe(arrows, radius, opt);


    %---

    wasHold=ishold;
    pipeH=surf(pipes.X, pipes.Y, pipes.Z, 'EdgeColor', 'none', 'FaceColor', 'r','FaceLighting', 'phong');
    % material default; 
    % lighting phong;
    %hold on
    arrowH=surf(arrow.X, arrow.Y, arrow.Z, 'EdgeColor', 'none', 'FaceColor', 'r','FaceLighting', 'phong');
    % material default; 
    % lighting phong

    if ~wasHold
       %hold off
    end% if

elseif bundled
    pipeH = [];
    arrowH = [];
end


function [pipe, arrow]=pipe(edges, radius, opt)
% TODO: non usare l'asse zeta, ma la direzione centripeta per definire le
% normali.
ARROWLEN=2.2*1.5;
ARROWRADIUS=2*1.5;
if nargin < 3
   opt=struct( ...
      'Radius', 2, ...
      'PrismSides', 8, ...
      'DrawMode', 'WHOLE', ... % 'WHOLE' 'HALF' 'DISPLACED'...
      'AspectRatio', 1, ...
      'ArrowType', 'END' ...% 'NONE' 'END' 'MIDDLE'
      );
end% if
if nargin>1 & ~isempty(radius)
   opt.Radius=radius;
end% if
% TODO: inizializzare pipe.X,Y,Z
nEdges=size(edges, 1);
arrowE=ceil(nEdges/2);
for ee=[1:nEdges-1]
   startPos=edges(ee, :);
   endPos=edges(ee+1, :);
   
   temp=[endPos-startPos];
   t_dir=temp./norm(temp);
   %
   if ee==1
      [pipe.X(1, :) pipe.Y(1, :) pipe.Z(1, :)] = basecontour(startPos, t_dir, opt);
   else
      temp=.5*(lastTDir+t_dir);
      startTdir=temp./norm(temp);
      [pipe.X(ee, :) pipe.Y(ee, :) pipe.Z(ee, :)] = basecontour(startPos, startTdir, opt);
   end% if 0
   %
   if strcmp(opt.ArrowType, 'MIDDLE') & ee==arrowE
      midPoint=.5*(startPos+endPos);
      startpoint=midPoint-.5*ARROWLEN*opt.Radius.*t_dir;
      arrow=arrowcontour(startpoint, ARROWLEN*t_dir, opt, ARROWRADIUS);
   end% if
   %
   lastTDir=t_dir;
end% for ee
if strcmp(opt.ArrowType, 'END')
   endPoint=endPos-ARROWLEN*t_dir;
   [pipe.X(nEdges, :) pipe.Y(nEdges, :) pipe.Z(nEdges, :)] = basecontour(endPoint, lastTDir, opt);
   arrow=arrowcontour(endPoint, ARROWLEN*t_dir, opt, ARROWRADIUS);
else
   [pipe.X(nEdges, :) pipe.Y(nEdges, :) pipe.Z(nEdges, :)] = basecontour(endPos, lastTDir, opt);
end% if
%

%==========================================================================
function arrow=arrowcontour(baseCenter, axis, opt, radiusFactor)

arrowLen=norm(axis);
t_dir=axis./arrowLen;

aStartPos=baseCenter;
aOpt1=opt;
aOpt1.Radius=0*opt.Radius;
[arrow.X(1, :) arrow.Y(1, :) arrow.Z(1, :)] = basecontour(aStartPos, t_dir, aOpt1);
aOpt2=aOpt1;
aOpt2.Radius=radiusFactor*opt.Radius;
[arrow.X(2, :) arrow.Y(2, :) arrow.Z(2, :)] = basecontour(aStartPos, t_dir, aOpt2);
aEndPos=baseCenter+arrowLen*opt.Radius.*t_dir;
aOpt3=opt;
aOpt3.Radius=0*opt.Radius;
[arrow.X(3, :) arrow.Y(3, :) arrow.Z(3, :)] = basecontour(aEndPos, t_dir, aOpt3);
if 1% utile se si usa il lighting phong
   arrow1=arrow;
   arrow.X=arrow1.X([1 2 2 3], :);
   arrow.Y=arrow1.Y([1 2 2 3], :);
   arrow.Z=arrow1.Z([1 2 2 3], :);
end% if


%--------------------------------------------------------------------------
function [X, Y, Z]=basecontour(center, t_dir, opt)
X_=1; Y_=2; Z_=3;
% z_dir=[0 0 1];
z_dir = center/norm(center);
z_dir = z_dir + [0 0 2];
z_dir = z_dir/norm(z_dir);

if t_dir(3)>1-eps
   n_xy=[1 0 0];
   n_z=[0 1 0];
else   
   temp=cross(t_dir, z_dir);
   n_xy=temp./norm(temp);
   n_z=cross(n_xy, t_dir);
end% if

switch opt.DrawMode
   case 'WHOLE'
      phi=linspace(-pi, pi, opt.PrismSides);
      rho=opt.Radius.*ones(size(phi));
   case 'HALF'
      phi=linspace(-pi/2, pi/2, opt.PrismSides);
      rho=opt.Radius.*ones(size(phi));
   case 'DISPLACED'
      phi=linspace(-pi/2, pi/2, opt.PrismSides);
      rho=opt.Radius.*cos(phi);
end% swich
% l_vec = ( n_xy.*sin(phi) + n_z.*cos(phi) );
X=center(X_) + rho .* ( n_xy(X_).*cos(phi) + opt.AspectRatio.*(n_z(X_).*sin(phi)) );
Y=center(Y_) + rho .* ( n_xy(Y_).*cos(phi) + opt.AspectRatio.*(n_z(Y_).*sin(phi)) );
Z=center(Z_) + rho .* ( n_xy(Z_).*cos(phi) + opt.AspectRatio.*(n_z(Z_).*sin(phi)) );


%%%%%%%%%%%%%%%%%%%%%%%%% Begin edge bundling code %%%%%%%%%%%%%%%%%%%%%%%%

function bundledEdges = edgebundle(edges, S)
    
    %calculate a bundle coefficient for each pair
    %stores significant pairs in matrix like: [edge1, edge2, bundleCoeff]
    pairs = calcbundlecoeffs(edges, S);
    originalEdges = edges;
    
    iterations = 100;
    
    for i = 1:iterations
        %calculate forces
        forces = findforces(edges, pairs, S, originalEdges);
        
        if i < 0.1 * iterations %reduce move limit as algorithm progresses, makes smoother bundles
            moveLimit = 2;
        elseif i < 0.2 * iterations
            moveLimit = 1;
        elseif i < 0.55 * iterations
            moveLimit = 0.5;
        elseif i < 0.85 * iterations
            moveLimit = 0.25;
        else
            moveLimit = 0.1;
        end
        
        forces(forces(:) > moveLimit) = moveLimit; %not farther than move limit
        forces(forces(:) < -moveLimit) = -moveLimit; %not farther than move limit
        
        
        
        edges = forces + edges; %average new location with original location to prevent excess movement
    end
    
    bundledEdges = edges;% + forces;
    
    
%this is the end of edgebundle function

function forces = findforces(edges, pairs, S, originalEdges)
    %needs to find force on each point of each edge (16 points/edge)
    %relevant edges: only those included in pairs matrix
    forces = zeros(size(edges)); %preallocate
    xc = 1; %x-coordinate
    yc = 2; %y-coordinate
    zc = 3; %z-coordinate
    
    for pair = 1:size(pairs, 1)
        %find force on each point on each edge for each pair
        affectedEdge = pairs(pair, 1); %feels the force
        affectingEdge = pairs(pair, 2); %applies the force
        
        for point = 2:(S - 1) % dont move endpoints
            xdist = edges(S*(affectingEdge - 1) + point, xc) - edges(S*(affectedEdge - 1) + point, xc); % subtract x coords
            ydist = edges(S*(affectingEdge - 1) + point, yc) - edges(S*(affectedEdge - 1) + point, yc); % subtract y coords
            zdist = edges(S*(affectingEdge - 1) + point, zc) - edges(S*(affectedEdge - 1) + point, zc); % subtract z coords
            dist = sqrt(xdist^2 + ydist^2 + zdist^2);
            
            if dist <= 1
                dist = 1;
            end
            
            bundlingCoeff = pairs(pair, 3);
            
            attractingForce = 10 * bundlingCoeff * [xdist, ydist, zdist] / (dist + eps)^2;
            
%             originalAdjacentPoints = [originalEdges(S*(affectedEdge - 1) + point - 1, :); originalEdges(S*(affectedEdge - 1) + point + 1, :)]; %same as below, but initially
%             adjacentPoints = [edges(S*(affectedEdge - 1) + point - 1, :); edges(S*(affectedEdge - 1) + point + 1, :)]; %points adjacent to point on affectedEdge
%             originalVectors(1, :) = originalAdjacentPoints(1, :) - edges(S*(affectedEdge - 1) + point, :); %vectors from point to adjacent points on same edge initially
%             originalVectors(2, :) = originalAdjacentPoints(2, :) - edges(S*(affectedEdge - 1) + point, :); %vectors from point to adjacent points on same edge initially
%             newVectors(1, :) = adjacentPoints(1, :) - edges(S*(affectedEdge - 1) + point, :); %same as above but current
%             newVectors(2, :) = adjacentPoints(2, :) - edges(S*(affectedEdge - 1) + point, :); %same as above but current
% 
%             affectedRestoringForce = newVectors - originalVectors %restoring force is a force that pulls the point back towards the points adjacent to it
%         
%             originalAdjacentPoints = [originalEdges(S*(affectingEdge - 1) + point - 1, :); originalEdges(S*(affectingEdge - 1) + point + 1, :)]; %same as below, but initially
%             adjacentPoints = [edges(S*(affectingEdge - 1) + point - 1, :); edges(S*(affectingEdge - 1) + point + 1, :)]; %points adjacent to point on affectedEdge
%             originalVectors(1, :) = originalAdjacentPoints(1, :) - edges(S*(affectingEdge - 1) + point, :); %vectors from point to adjacent points on same edge initially
%             originalVectors(2, :) = originalAdjacentPoints(2, :) - edges(S*(affectingEdge - 1) + point, :); %vectors from point to adjacent points on same edge initially
%             newVectors(1, :) = adjacentPoints(1, :) - edges(S*(affectingEdge - 1) + point, :); %same as above but current
%             newVectors(2, :) = adjacentPoints(2, :) - edges(S*(affectingEdge - 1) + point, :); %same as above but current
% 
%             affectingRestoringForce = newVectors - originalVectors %restoring force is a force that pulls the point back towards the points adjacent to it
%         
%             
%             forces(point + S*(affectedEdge - 1), [xc, yc, zc]) = attractingForce + affectedRestoringForce(1, :)/30 + affectedRestoringForce(2, :)/30;
%             forces(point + S*(affectingEdge - 1), [xc, yc, zc]) = -attractingForce + affectingRestoringForce(1, :)/30 + affectingRestoringForce(2, :)/30; %reciprocal force
        
            
            forces(point + S*(affectedEdge - 1), [xc, yc, zc]) = attractingForce;
            forces(point + S*(affectingEdge - 1), [xc, yc, zc]) = -attractingForce;
            
        end
        
    end
    
    
%end findforces function


function pairs = calcbundlecoeffs(edges, S)
    pairs = []; %contains pairs of edges and their bundling coefficients (0->1)
    coeffThreshold = 0.2; % can be from 0 (max bundling) to 1 (no bundling)

    for e1 = 1:size(edges, 1)/S %1:number of edges
        for e2 = (e1 + 1):size(edges, 1)/S
            distCoeff = finddistance(edges, e1, e2, S); % calculates distance between end points and returns distCoeff
            angleCoeff = findangle(edges, e1, e2, S); % calculates angle between edges and returns angleCoeff
            bundlingCoeff = distCoeff * angleCoeff; % the affinity of a given pair to bundle (0=least 1=most)
            % store each pair with coefficient above threshold in pairs matrix
            % only store if coefficient is above threshold

            if bundlingCoeff >= coeffThreshold
                pairs = [pairs; e1, e2, bundlingCoeff];
            end
        end
    end
    

%this is the end of calcbundlecoeffs function


function distCoeff = finddistance(edges, e1, e2, S)
    %could be replaces by norm?
    %calculates average distance between endpoints
    e1pt1 = edges((e1-1)*S+1, :); % edge 1 start coords
    e2pt1 = edges((e2-1)*S+1, :); % edge 2 start coords
    dist1 = sqrt((e1pt1(1)-e2pt1(1))^2 + (e1pt1(2)-e2pt1(2))^2 + (e1pt1(3)-e2pt1(3))^2); % dist between start coords
    e1pt2 = edges(e1*S, :); % edge 1 end coords
    e2pt2 = edges(e2*S, :); % edge 2 end coords
    dist2 = sqrt((e1pt2(1)-e2pt2(1))^2 + (e1pt2(2)-e2pt2(2))^2 + (e1pt2(3)-e2pt2(3))^2); % dist between end coords
    
    D = 20; % limit of sum of dists 1 and 2 before bundling coefficient is decreased
    distCoeff = D / (dist1 + dist2);
    if distCoeff > 1
        distCoeff = 1;
    end
    
%this is the end of finddistance function
   

function angleCoeff = findangle(edges, e1, e2, S)
    %calculates angle in 3D space
    %make edges into vectors
    v1 = edges(e1*S, :) - edges((e1-1)*S+1, :); % subtract start coords from end coords
    v2 = edges(e2*S, :) - edges((e2-1)*S+1, :); % subtract start coords from end coords
    radians = atan2(norm(cross(v1, v2)), dot(v1, v2));
    
    if radians > pi/2 % edges at angles greater than 90 deg don't bundle at all
        radians = pi/2;
    end
    
    angle = radians * 180/pi;
    angleCoeff = cos(radians); %scale from 0 to 1

%this is the end of findangle function


%%%%%%%%%%%%%%%%%%%%%%%%% End edge bundling code %%%%%%%%%%%%%%%%%%%%%%%%%%

