clear all
close all

addpath('./activeplot');
addpath('./activeplot/activeBrain');
addpath('./export_fig');
name = 'ArrowsGrangerCausality_TheWall1_Task_HighGamma@10Hz_ARModel-Order10_pval-0.05_bfc.mat';
load(name);

% Load MNI brain
load('MNI_brain.mat');
brainStruct.vcontribs = vcontribs;
brainStruct.viewstruct = viewstruct;
brainStruct.cmapstruct = cmapstruct;
brainStruct.cortex = cortex;
brainStruct.tala = tala;
brainStruct.ix = 1;
brainStruct.viewstruct.what2view = {'brain'};
brainStruct.cmapstruct.enablecolorbar = 0;
brainStruct.viewstruct.viewvect = [-90 0];
brainStruct.viewstruct.lightpos = [-200,0,0];


for idx=1:length(Info_GC_Analysis),
    p(idx) = Info_GC_Analysis{idx}.p;
end

[p_sorted,p_sorted_index] = sort(p);


for idxA=1:length(Info_GC_Analysis),
    for idxB=1:length(Info_GC_Analysis),
        d_start(idxA,idxB) = sqrt(sum(Info_GC_Analysis{idxA}.CoordStart - Info_GC_Analysis{idxB}.CoordStart).^2);

        d_end(idxA,idxB)   = sqrt(sum(Info_GC_Analysis{idxA}.CoordEnd - Info_GC_Analysis{idxB}.CoordEnd).^2);
        
    end
end

   
duplicates = double(d_start < 10 & d_end < 10);
surf(duplicates), view(2), axis tight;

list_remove = [];
for idx=1:length(Info_GC_Analysis),

    index = setdiff(find(duplicates(idx,:)),idx);
    
    if ~isempty(index),
       
        set_index = [idx;index(:)];
        
        [p_set,p_set_index] = sort(p(set_index));        
        
        list_remove = [list_remove;set_index(p_set_index(2:end))];
        
    end
    
    
end

for idx=1:length(Info_GC_Analysis),
    d(idx) = sqrt(sum((Info_GC_Analysis{idx}.CoordStart-Info_GC_Analysis{idx}.CoordEnd).^2));
end

list_remove = [list_remove;find(d(:) < 10)];

Info_GC_Analysis = Info_GC_Analysis(setdiff(p_sorted_index,unique(list_remove)));

clear p

for idx=1:length(Info_GC_Analysis),
    p(idx) = Info_GC_Analysis{idx}.p;
end

[p_sorted,p_sorted_index] = sort(p);




% these parameters define the size of the arrows
%ArSzLt = [0.5 2];
ArSzLt = [1 2];


%Info_GC_Analysis = Info_GC_Analysis(p_sorted_index(p_sorted_index(end-9:-2:1)));
Info_GC_Analysis = Info_GC_Analysis(p_sorted_index(p_sorted_index(end:-1:1)));


ct = length(Info_GC_Analysis);
if (ct>1)
    noarrows = length(Info_GC_Analysis);
    coorStart = NaN(noarrows,3); coorEnd = coorStart; pv = NaN(noarrows,1);
    for arrow=1:noarrows
        coorStart(arrow,:) = Info_GC_Analysis{arrow}.CoordStart; 
        coorEnd(arrow,:)   = Info_GC_Analysis{arrow}.CoordEnd;
        pv(arrow,1) = Info_GC_Analysis{arrow}.p;
    end
    id = pv == 0;
    pv(id) = 1e-30;
    pv = -log10(pv);
    % plot arrows
    plotArrows(brainStruct,coorStart, coorEnd, pv, ArSzLt, name);
    plotBalls(coorStart, 'r', 1.5); plotBalls(coorEnd, 'r', 1.5); 

else
    plotArrows(brainStruct,[], [], [], ArSzLt, name);
end